#ifndef BISON___LYPARSER_TAB_H
# define BISON___LYPARSER_TAB_H

#ifndef YYSTYPE
typedef union {
	nodemin *minimal;
	nodegeneric *generic;
	nodec *c;
	nodei *i;
	node2i *t;
	node4i *f;
	nodeb *b;
	noden *n;
	nodeglist *branch;
	nodeid *id;
	nodegstr *gstr;
	nodemus *music;	
	noder *r;
	GList *scm;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;

  int last_line;
  int last_column;
} yyltype;

# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

# define	DENEMO_MEASURES	257
# define	INITIAL_CLEF	258
# define	INITIAL_KEYSIG	259
# define	INITIAL_TIMESIG	260
# define	PARSE_ERROR	261
# define	TEXT	262
# define	staffcontext	263
# define	voicecontext	264
# define	lyricscontext	265
# define	figuredbasscontext	266
# define	endcontext	267
# define	MUSICMODE	268
# define	TONEOPTION	269
# define	DYNAMICMARK	270
# define	AUTOCHANGE	271
# define	ALIAS	272
# define	APPLY	273
# define	ARPEGGIO	274
# define	DYNAMICSCRIPT	275
# define	ACCEPTS	276
# define	ALTERNATIVE	277
# define	BAR	278
# define	BREATHE	279
# define	CHORDMODIFIERS	280
# define	CHORDS	281
# define	CHAR_T	282
# define	CLEF_	283
# define	CM_T	284
# define	CONSISTS	285
# define	SEQUENTIAL	286
# define	SIMULTANEOUS	287
# define	GROBDESCRIPTIONS	288
# define	CONSISTSEND	289
# define	DENIES	290
# define	DURATION	291
# define	EXTENDER	292
# define	FIGURES	293
# define	FIGURE_OPEN	294
# define	FIGURE_CLOSE	295
# define	FIGURE_BRACKET_CLOSE	296
# define	FIGURE_BRACKET_OPEN	297
# define	GLISSANDO	298
# define	GRACE	299
# define	HEADER	300
# define	HYPHEN	301
# define	IN_T	302
# define	INVALID	303
# define	KEY	304
# define	LYRICS	305
# define	MARK	306
# define	MULTI_MEASURE_REST	307
# define	MIDI	308
# define	MM_T	309
# define	PITCH	310
# define	DEFAULT	311
# define	NAME	312
# define	PITCHNAMES	313
# define	NOTES	314
# define	PAPER	315
# define	PARTIAL	316
# define	PENALTY	317
# define	PROPERTY	318
# define	OVERRIDE	319
# define	SET	320
# define	REVERT	321
# define	PT_T	322
# define	RELATIVE	323
# define	REMOVE	324
# define	REPEAT	325
# define	ADDLYRICS	326
# define	PARTCOMBINE	327
# define	SCM_T	328
# define	SCORE	329
# define	SCRIPT	330
# define	SKIP	331
# define	SPANREQUEST	332
# define	STYLESHEET	333
# define	COMMANDSPANREQUEST	334
# define	TEMPO	335
# define	OUTPUTPROPERTY	336
# define	TIME_T	337
# define	TIMES	338
# define	TRANSLATOR	339
# define	TRANSPOSE	340
# define	TYPE	341
# define	UNSET	342
# define	CONTEXT	343
# define	REST	344
# define	E_CHAR	345
# define	E_EXCLAMATION	346
# define	E_SMALLER	347
# define	E_BIGGER	348
# define	E_OPEN	349
# define	E_CLOSE	350
# define	E_LEFTSQUARE	351
# define	E_RIGHTSQUARE	352
# define	E_TILDE	353
# define	E_BACKSLASH	354
# define	CHORD_BASS	355
# define	CHORD_COLON	356
# define	CHORD_MINUS	357
# define	CHORD_CARET	358
# define	FIGURE_SPACE	359
# define	DIGIT	360
# define	NOTENAME_PITCH	361
# define	TONICNAME_PITCH	362
# define	CHORDMODIFIER_PITCH	363
# define	DURATION_IDENTIFIER	364
# define	FRACTION	365
# define	IDENTIFIER	366
# define	SCORE_IDENTIFIER	367
# define	MUSIC_OUTPUT_DEF_IDENTIFIER	368
# define	NUMBER_IDENTIFIER	369
# define	REQUEST_IDENTIFIER	370
# define	MUSIC_IDENTIFIER	371
# define	TRANSLATOR_IDENTIFIER	372
# define	STRING_IDENTIFIER	373
# define	SCM_IDENTIFIER	374
# define	RESTNAME	375
# define	STRING_	376
# define	UNSIGNED	377
# define	REAL	378
# define	UNARY_MINUS	379


extern YYSTYPE lylval;

#endif /* not BISON___LYPARSER_TAB_H */
